/*
Interactions

`Interactions are managed by our flow designer in UI, what you can control via api is how you start and run interaction flow for contact sending events.  Interaction can start in a multiple ways:  - EntryPont - when contact scans QR code ar opens entry point link  - event as trigger - this way you can start flow for single contact  ## Events Events are a data structure related to some contact action. You can use them whenever you want to start active interaction for contact but also inside interaction flow you can define points wher system should wait for custom event sent from your side.   Depending on your use case our predefined interactions might have defined events and instruction what events should be sent.  Events can be sent directly using our REST Api or triggered automatically by our integration modules.  ## Adding attributes to events Adding attributest to event can personalize communication, select branch flow based on attribute value or use them as perameters in other interaction flow actions. Use `body` property in event structure to add key-value attributes. 

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package interactions

import (
	"encoding/json"
	"fmt"
)

// ActionType the model 'ActionType'
type ActionType string

// List of ActionType
const (
	WAIT ActionType = "wait"
	BRANCH ActionType = "branch"
	MESSAGE_LINK ActionType = "message_link"
	SCRIPT_START ActionType = "script_start"
	SCRIPT_V2_START ActionType = "script_v2_start"
	ALERT_USER ActionType = "alert_user"
	STORE_CONTACT_DATA ActionType = "store_contact_data"
	ACTIVITY ActionType = "activity"
	CONTACT_SEGMENT ActionType = "contact_segment"
	CONTACT_UPDATE ActionType = "contact_update"
	CONTACT_EXTERNAL_ID ActionType = "contact_external_id"
	TRANSACTION_UPDATE ActionType = "transaction_update"
	VLOOP_CREATE_REFERRAL ActionType = "vloop_create_referral"
	VLOOP_COMPLETE_FRIEND ActionType = "vloop_complete_friend"
	SIGNATURES_CREATE_SIGNATURE ActionType = "signatures_create_signature"
	SEND_EVENT ActionType = "send_event"
	ENTRY_POINT ActionType = "entry_point"
	ENTRY_POINT_UPDATE ActionType = "entry_point_update"
	API_FETCH_DATA ActionType = "api_fetch_data"
	API_FETCH_FILE ActionType = "api_fetch_file"
	AI_CHATBOT ActionType = "ai_chatbot"
	WHATSAPP_NOTIFICATION ActionType = "whatsapp_notification"
	SMS_NOTIFICATION ActionType = "sms_notification"
	CUSTOM_SYNC_CONTACT ActionType = "custom_sync_contact"
	CUSTOM_CREATE_LOYALTY ActionType = "custom_create_loyalty"
	CUSTOM_CHANGE_POINTS ActionType = "custom_change_points"
	CUSTOM_ASSIGN_COUPON ActionType = "custom_assign_coupon"
	CUSTOM_REDEEM_COUPON ActionType = "custom_redeem_coupon"
	CUSTOM_GET_RECEIPT ActionType = "custom_get_receipt"
	CUSTOM_CREATE_PAYMENT_LINK ActionType = "custom_create_payment_link"
	CUSTOM_PAY_ANOTHER_ACCOUNT ActionType = "custom_pay_another_account"
	CUSTOM_CREATE_DOCUMENT ActionType = "custom_create_document"
	USER_NOTIFICATION ActionType = "user_notification"
)

// All allowed values of ActionType enum
var AllowedActionTypeEnumValues = []ActionType{
	"wait",
	"branch",
	"message_link",
	"script_start",
	"script_v2_start",
	"alert_user",
	"store_contact_data",
	"activity",
	"contact_segment",
	"contact_update",
	"contact_external_id",
	"transaction_update",
	"vloop_create_referral",
	"vloop_complete_friend",
	"signatures_create_signature",
	"send_event",
	"entry_point",
	"entry_point_update",
	"api_fetch_data",
	"api_fetch_file",
	"ai_chatbot",
	"whatsapp_notification",
	"sms_notification",
	"custom_sync_contact",
	"custom_create_loyalty",
	"custom_change_points",
	"custom_assign_coupon",
	"custom_redeem_coupon",
	"custom_get_receipt",
	"custom_create_payment_link",
	"custom_pay_another_account",
	"custom_create_document",
	"user_notification",
}

func (v *ActionType) UnmarshalJSON(src []byte) error {
	var value string
	err := json.Unmarshal(src, &value)
	if err != nil {
		return err
	}
	enumTypeValue := ActionType(value)
	for _, existing := range AllowedActionTypeEnumValues {
		if existing == enumTypeValue {
			*v = enumTypeValue
			return nil
		}
	}

	return fmt.Errorf("%+v is not a valid ActionType", value)
}

// NewActionTypeFromValue returns a pointer to a valid ActionType
// for the value passed as argument, or an error if the value passed is not allowed by the enum
func NewActionTypeFromValue(v string) (*ActionType, error) {
	ev := ActionType(v)
	if ev.IsValid() {
		return &ev, nil
	} else {
		return nil, fmt.Errorf("invalid value '%v' for ActionType: valid values are %v", v, AllowedActionTypeEnumValues)
	}
}

// IsValid return true if the value is valid for the enum, false otherwise
func (v ActionType) IsValid() bool {
	for _, existing := range AllowedActionTypeEnumValues {
		if existing == v {
			return true
		}
	}
	return false
}

// Ptr returns reference to ActionType value
func (v ActionType) Ptr() *ActionType {
	return &v
}

type NullableActionType struct {
	value *ActionType
	isSet bool
}

func (v NullableActionType) Get() *ActionType {
	return v.value
}

func (v *NullableActionType) Set(val *ActionType) {
	v.value = val
	v.isSet = true
}

func (v NullableActionType) IsSet() bool {
	return v.isSet
}

func (v *NullableActionType) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableActionType(val *ActionType) *NullableActionType {
	return &NullableActionType{value: val, isSet: true}
}

func (v NullableActionType) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableActionType) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}

